<Cabbage>
form caption("Combo Test") size(300, 100), guiMode("queue") pluginId("def1")
rslider bounds(4, 46, 62, 67), channel("fileNumber"), range(1, 3, 1, 1, 1), text("File"), trackerColour(0, 255, 0, 255), outlineColour(0, 0, 0, 50), textColour(0, 0, 0, 255)
combobox bounds(6, 22, 200, 20), populate("*.wav", "./files"), channelType("string"), value("01"), channel("combo1")
button bounds(74, 50, 80, 40) channel("playSample"), text("Play current sample")
</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d
</CsOptions>
<CsInstruments>
; Initialize the global variables. 
ksmps = 32
nchnls = 2
0dbfs = 1

instr 1
    SFileType cabbageGet "combo1", "fileType"       ; get file type as set by populate()
    SPath cabbageGet "combo1", "currentDir"         ; get the directory that is passed to poplate()
    SCsdPath cabbageGet "CSD_PATH"                  ; get .csd directory
    SFilesDir sprintf  "%s/%s/", SCsdPath, SPath    ; construct full path from absolute and relative paths
    SFile, kComboChanged cabbageGetValue "combo1"   ; get file name
    SFileName cabbageGetFileNoExtension sprintfk("%s/%s", SFilesDir, SFile) ;get filename from full name

    kButton, kButtonTrig cabbageGetValue "playSample"
    if kButtonTrig == 1 then 
        ;set currentFile string channel - event doesn't do string...
        chnset sprintfk("%s%s%s", SFilesDir, SFileName, strsubk(SFileType, 1, -1)), "currentFile"        
        event "i", 2, 0, 1                                              
    endif

    kSlider, kSliderTrig cabbageGetValue "fileNumber"
   
    if kSliderTrig == 1 then
        ;update combo and set current file
        cabbageSetValue "combo1", sprintfk("%02d", kSlider), kSliderTrig   
        chnset sprintfk("%s%02d%s", SFilesDir, kSlider, strsubk(SFileType, 1, -1)), "currentFile"                
    endif

endin

instr 2
    SFile chnget "currentFile"
    prints SFile
    if filevalid(SFile) == 1 then
        p3 = filelen(SFile)
        a1, a2 diskin2 SFile, 1
        outs a1, a1
    endif
endin

</CsInstruments>
<CsScore>
;causes Csound to run for about 7000 years...
f0 z
;starts instrument 1 and runs it for a week
i1 0 z 
</CsScore>
</CsoundSynthesizer>
